#include <iostream>
#include<math.h>
using namespace std;


int main()
{
    int n,k,rez=0,x=2,pj,pz,kj,kz,y=0;
    cin>>n>>k;
    int m[n][n];
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
            cin>>m[i][j];
    }
    for(int i=1;i<k;i++)
    {
        for(int j=0;j<n;j++)
        {
            for(int z=0;z<n;z++)
            {
                if((i==m[j][z])&&(x==2))
                {
                    pj=j;
                    pz=z;
                    x++;
                    y++;
                }
                else if((i==m[j][z])&&((j-kj)<2)&&((z-kz)<2))
                {
                    kj=j;
                    kz=z;
                    y++;
                }
            }
        }
        if(y<2)
            rez++;
        else if((kj-pj)!=(kz-pz))
        {
            for(int j=pz+1;j<kz;j++)
            {
                if(i!=m[kj][j])
                {
                    x=0;
                    break;
                }
                else
                    x=1;
            }
            if(x)
                rez++;
        }
        x=2;
        y=0;
    }
    cout<<rez<<endl;
    return 0;
}